﻿''
'' ConsoleVB
''
'' Copyright (c) 2016 http://www.curict.com
'' This software is released under the MIT License, see LICENSE.txt.
''

Module Module1

    Sub Main()
        ' 様々なデータ型で、データテーブルに列を追加
        Dim dataTable As DataTable = New DataTable()
        dataTable.Columns.Add("col_Boolean", GetType(System.Boolean))
        dataTable.Columns.Add("col_Byte", GetType(System.Byte))
        dataTable.Columns.Add("col_Byte()", GetType(System.Byte()))
        dataTable.Columns.Add("col_Char", GetType(System.Char))
        dataTable.Columns.Add("col_DateTime", GetType(System.DateTime))
        dataTable.Columns.Add("col_Decimal", GetType(System.Decimal))
        dataTable.Columns.Add("col_Double", GetType(System.Double))
        dataTable.Columns.Add("col_Guid", GetType(System.Guid))
        dataTable.Columns.Add("col_Int16", GetType(System.Int16))
        dataTable.Columns.Add("col_Int32", GetType(System.Int32))
        dataTable.Columns.Add("col_Int64", GetType(System.Int64))
        dataTable.Columns.Add("col_SByte", GetType(System.SByte))
        dataTable.Columns.Add("col_Single", GetType(System.Single))
        dataTable.Columns.Add("col_String", GetType(System.String))
        dataTable.Columns.Add("col_TimeSpan", GetType(System.TimeSpan))
        dataTable.Columns.Add("col_UInt16", GetType(System.UInt16))
        dataTable.Columns.Add("col_UInt32", GetType(System.UInt32))
        dataTable.Columns.Add("col_UInt64", GetType(System.UInt64))

        ' -------------------------------------------------------
        ' Nothingを設定して例外が発生するか調べる
        ' -------------------------------------------------------
        Dim row As DataRow = dataTable.NewRow()
        'row("col_Boolean") = Nothing   ' 例外発生
        'row("col_Byte") = Nothing      ' 例外発生
        row("col_Byte()") = Nothing
        'row("col_Char") = Nothing      ' 例外発生
        'row("col_DateTime") = Nothing  ' 例外発生
        'row("col_Decimal") = Nothing   ' 例外発生
        'row("col_Double") = Nothing    ' 例外発生
        'row("col_Guid") = Nothing      ' 例外発生
        'row("col_Int16") = Nothing     ' 例外発生
        'row("col_Int32") = Nothing     ' 例外発生
        'row("col_Int64") = Nothing     ' 例外発生
        'row("col_SByte") = Nothing     ' 例外発生
        'row("col_Single") = Nothing    ' 例外発生
        row("col_String") = Nothing
        'row("col_TimeSpan") = Nothing  ' 例外発生
        'row("col_UInt16") = Nothing    ' 例外発生
        'row("col_UInt32") = Nothing    ' 例外発生
        'row("col_UInt64") = Nothing    ' 例外発生


        ' -------------------------------------------------------
        ' Nothingの判定
        ' -------------------------------------------------------

        If row.IsNull("col_String") Then
            ' 表示される
            Console.WriteLine("IsNULLです。")
        End If

        If row("col_String") Is DBNull.Value Then
            ' 表示される
            Console.WriteLine("DBNull.Valueです。")
        End If

        If row("col_String") Is Nothing Then
            ' 表示されない
            Console.WriteLine("Nothingです。")
        End If

        Console.ReadLine()
    End Sub

End Module
